<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>EDMA3 Resource Manager: Channel Specific Interface</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.9 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Channel Specific Interface<br>
<small>
[<a class="el" href="group__Edma3RMIntrMgrInst.html">Instance Wide Interface</a>]</small>
</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Modules</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Edma3ResType.html">Resource Type</a></td></tr>

<tr><td colspan="2"><br><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef void(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Edma3RMIntrMgrChannel.html#gadca81927be74261ef874009bf8e37d3">EDMA3_RM_TccCallback</a> )(unsigned int tcc, <a class="el" href="group__Edma3RMStatus.html#g6552b0f8faaf17b884686da3bdcb955f">EDMA3_RM_TccStatus</a> status, void *appData)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">TCC callback - caters to channel-specific events like "Event Miss Error" or "Transfer Complete". Runs in ISR context.  <a href="#gadca81927be74261ef874009bf8e37d3"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">EDMA3_RM_Result&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Edma3RMIntrMgrChannel.html#gd57281a3cabf45b1520007a1a78f6a53">EDMA3_RM_registerTccCb</a> (EDMA3_RM_Handle hEdmaResMgr, const <a class="el" href="structEDMA3__RM__ResDesc.html">EDMA3_RM_ResDesc</a> *channelObj, unsigned int tcc, <a class="el" href="group__Edma3RMIntrMgrChannel.html#gadca81927be74261ef874009bf8e37d3">EDMA3_RM_TccCallback</a> tccCb, void *cbData)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Register Interrupt / Completion Handler for a given TCC.  <a href="#gd57281a3cabf45b1520007a1a78f6a53"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">EDMA3_RM_Result&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Edma3RMIntrMgrChannel.html#g34a841202d01ea2e2a35747aa873a984">EDMA3_RM_unregisterTccCb</a> (EDMA3_RM_Handle hEdmaResMgr, const <a class="el" href="structEDMA3__RM__ResDesc.html">EDMA3_RM_ResDesc</a> *channelObj)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unregister the previously registered callback function against a DMA/QDMA channel.  <a href="#g34a841202d01ea2e2a35747aa873a984"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Channel Specific Interface of the EDMA3 Interrupt Manager Layer <hr><h2>Typedef Documentation</h2>
<a class="anchor" name="gadca81927be74261ef874009bf8e37d3"></a><!-- doxytag: member="edma3_rm.h::EDMA3_RM_TccCallback" ref="gadca81927be74261ef874009bf8e37d3" args=")(unsigned int tcc, EDMA3_RM_TccStatus status, void *appData)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef void(*  <a class="el" href="group__Edma3RMIntrMgrChannel.html#gadca81927be74261ef874009bf8e37d3">EDMA3_RM_TccCallback</a>)(unsigned int tcc, <a class="el" href="group__Edma3RMStatus.html#g6552b0f8faaf17b884686da3bdcb955f">EDMA3_RM_TccStatus</a> status, void *appData)          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
TCC callback - caters to channel-specific events like "Event Miss Error" or "Transfer Complete". Runs in ISR context. 
<p>
appData is passed by the application during Register'ing of TCC Callback function. 
</div>
</div><p>
<hr><h2>Function Documentation</h2>
<a class="anchor" name="gd57281a3cabf45b1520007a1a78f6a53"></a><!-- doxytag: member="edma3_rm.h::EDMA3_RM_registerTccCb" ref="gd57281a3cabf45b1520007a1a78f6a53" args="(EDMA3_RM_Handle hEdmaResMgr, const EDMA3_RM_ResDesc *channelObj, unsigned int tcc, EDMA3_RM_TccCallback tccCb, void *cbData)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">EDMA3_RM_Result EDMA3_RM_registerTccCb           </td>
          <td>(</td>
          <td class="paramtype">EDMA3_RM_Handle&nbsp;</td>
          <td class="paramname"> <em>hEdmaResMgr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structEDMA3__RM__ResDesc.html">EDMA3_RM_ResDesc</a> *&nbsp;</td>
          <td class="paramname"> <em>channelObj</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>tcc</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Edma3RMIntrMgrChannel.html#gadca81927be74261ef874009bf8e37d3">EDMA3_RM_TccCallback</a>&nbsp;</td>
          <td class="paramname"> <em>tccCb</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>cbData</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Register Interrupt / Completion Handler for a given TCC. 
<p>
This function enables the interrupts in IESR/IESRH, only if the callback function provided by the user is NON-NULL. Moreover, if a call-back function is already registered against that TCC, the API fails with the error code EDMA3_RM_E_CALLBACK_ALREADY_REGISTERED. For a NULL callback function, this API returns error.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>hEdmaResMgr</em>&nbsp;</td><td>[IN] Handle to the previously opened EDMA3 Resource Manager Instance </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>channelObj</em>&nbsp;</td><td>[IN] Channel ID and type (DMA or QDMA Channel), allocated earlier, and corresponding to which a callback function needs to be registered against the associated TCC. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>tcc</em>&nbsp;</td><td>[IN] TCC against which the handler needs to be registered. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>tccCb</em>&nbsp;</td><td>[IN] The Callback function to be registered against the TCC. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>cbData</em>&nbsp;</td><td>[IN] Callback data to be passed while calling the callback function.</td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>EDMA3_RM_SOK or EDMA3_RM Error Code</dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This function is re-entrant for unique tcc values. It is non- re-entrant for same tcc value. </dd></dl>

<p>
Enable the interrupts in IESR/IESRH, only if the Callback function is NOT NULL.
<p>References <a class="el" href="edma3resmgr_8h_source.html#l00295">EDMA3_RM_TccCallbackParams::cbData</a>, <a class="el" href="edma3__rm_8h_source.html#l00668">EDMA3_RM_E_CALLBACK_ALREADY_REGISTERED</a>, <a class="el" href="edma3__rm_8h_source.html#l00641">EDMA3_RM_E_INVALID_PARAM</a>, <a class="el" href="edma3__rm_8h_source.html#l00227">EDMA3_RM_RES_DMA_CHANNEL</a>, <a class="el" href="edma3__rm_8h_source.html#l00230">EDMA3_RM_RES_QDMA_CHANNEL</a>, <a class="el" href="edma3resmgr_8h_source.html#l00184">EDMA3_RM_Obj::gblCfgParams</a>, <a class="el" href="edma3__rm_8h_source.html#l00720">EDMA3_RM_GblConfigParams::numDmaChannels</a>, <a class="el" href="edma3__rm_8h_source.html#l00723">EDMA3_RM_GblConfigParams::numQdmaChannels</a>, <a class="el" href="edma3__rm_8h_source.html#l00729">EDMA3_RM_GblConfigParams::numTccs</a>, <a class="el" href="edma3resmgr_8h_source.html#l00215">EDMA3_RM_Instance::pResMgrObjHandle</a>, <a class="el" href="edma3__rm_8h_source.html#l00254">EDMA3_RM_ResDesc::resId</a>, <a class="el" href="edma3resmgr_8h_source.html#l00209">EDMA3_RM_Instance::shadowRegs</a>, <a class="el" href="edma3resmgr_8h_source.html#l00292">EDMA3_RM_TccCallbackParams::tccCb</a>, and <a class="el" href="edma3__rm_8h_source.html#l00257">EDMA3_RM_ResDesc::type</a>.</p>

</div>
</div><p>
<a class="anchor" name="g34a841202d01ea2e2a35747aa873a984"></a><!-- doxytag: member="edma3_rm.h::EDMA3_RM_unregisterTccCb" ref="g34a841202d01ea2e2a35747aa873a984" args="(EDMA3_RM_Handle hEdmaResMgr, const EDMA3_RM_ResDesc *channelObj)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">EDMA3_RM_Result EDMA3_RM_unregisterTccCb           </td>
          <td>(</td>
          <td class="paramtype">EDMA3_RM_Handle&nbsp;</td>
          <td class="paramname"> <em>hEdmaResMgr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structEDMA3__RM__ResDesc.html">EDMA3_RM_ResDesc</a> *&nbsp;</td>
          <td class="paramname"> <em>channelObj</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Unregister the previously registered callback function against a DMA/QDMA channel. 
<p>
This function unregisters the previously registered callback function against a DMA/QDMA channel by removing any stored callback function. Moreover, it clears the interrupt enable register (IESR/IESRH) by writing to the IECR/ IECRH register, for the TCC associated with that particular channel.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>hEdmaResMgr</em>&nbsp;</td><td>[IN] Handle to the previously opened EDMA3 Resource Manager Instance </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>channelObj</em>&nbsp;</td><td>[IN] Channel ID and type, allocated earlier (DMA or QDMA Channel ONLY), and corresponding to which a TCC is there. Against that TCC, the callback needs to be un-registered.</td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>EDMA3_RM_SOK or EDMA3_RM Error Code.</dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This function is re-entrant for unique (channelObj-&gt;type + channelObj-&gt;resId) combination. It is non-re-entrant for same channelObj Resource. </dd></dl>

<p>References <a class="el" href="edma3resmgr_8h_source.html#l00295">EDMA3_RM_TccCallbackParams::cbData</a>, <a class="el" href="edma3__rm_8h_source.html#l00641">EDMA3_RM_E_INVALID_PARAM</a>, <a class="el" href="edma3__rm_8h_source.html#l00227">EDMA3_RM_RES_DMA_CHANNEL</a>, <a class="el" href="edma3__rm_8h_source.html#l00230">EDMA3_RM_RES_QDMA_CHANNEL</a>, <a class="el" href="edma3resmgr_8h_source.html#l00184">EDMA3_RM_Obj::gblCfgParams</a>, <a class="el" href="edma3__rm_8h_source.html#l00720">EDMA3_RM_GblConfigParams::numDmaChannels</a>, <a class="el" href="edma3__rm_8h_source.html#l00723">EDMA3_RM_GblConfigParams::numQdmaChannels</a>, <a class="el" href="edma3resmgr_8h_source.html#l00215">EDMA3_RM_Instance::pResMgrObjHandle</a>, <a class="el" href="edma3__rm_8h_source.html#l00254">EDMA3_RM_ResDesc::resId</a>, <a class="el" href="edma3resmgr_8h_source.html#l00209">EDMA3_RM_Instance::shadowRegs</a>, <a class="el" href="edma3resmgr_8h_source.html#l00292">EDMA3_RM_TccCallbackParams::tccCb</a>, and <a class="el" href="edma3__rm_8h_source.html#l00257">EDMA3_RM_ResDesc::type</a>.</p>

</div>
</div><p>
</div>
<hr size="1"><address style="text-align: right;"><small>Generated on Tue Jul 7 19:26:48 2009 for EDMA3 Resource Manager by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.9 </small></address>
</body>
</html>
